Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(copie de travail)
@@ -1398,7 +2314,7 @@
  *
  * @return	boolean		true if the plugin was successfully registered
  */
-HTMLArea.prototype.registerPlugin = function(plugin) {
+HTMLArea.Editor.prototype.registerPlugin = function(plugin) {
 	var pluginName = plugin;
 	if (typeof(plugin) === "string") {
 		try {
@@ -1429,16 +2345,6 @@
 };
 
 /*
- * Get the instance of the specified plugin, if it exists
- *
- * @param	string		pluginName: the name of the plugin
- * @return	object		the plugin instance or null
- */
-HTMLArea.prototype.getPluginInstance = function(pluginName) {
-	return (this.plugins[pluginName] ? this.plugins[pluginName].instance : null);
-};
-
-/*
  * Load the required plugin script
  */
 HTMLArea.loadPlugin = function (pluginName, url, asynchronous) {
@@ -1468,7 +2374,7 @@
 /*
  * Get the url of some image
  */
-HTMLArea.prototype.imgURL = function(file, plugin) {
+HTMLArea.Editor.prototype.imgURL = function(file, plugin) {
 	if (typeof(plugin) == "undefined") return _editor_skin + this.config.imgURL + file;
 		else return _editor_skin + this.config.imgURL + plugin + "/" + file;
 };
@@ -1476,7 +2382,7 @@
 /*
  * Get the url of some popup
  */
-HTMLArea.prototype.popupURL = function(file) {
+HTMLArea.Editor.prototype.popupURL = function(file) {
 	var url = "";
 	if(file.match(/^plugin:\/\/(.*?)\/(.*)/)) {
 		var pluginId = RegExp.$1;
@@ -1509,36 +2415,22 @@
 	return txt;
 };
 
-HTMLArea.prototype.forceRedraw = function() {
-	this._doc.body.style.visibility = "hidden";
-	this._doc.body.style.visibility = "visible";
+HTMLArea.Editor.prototype.forceRedraw = function() {
+	this.htmlArea.doLayout();
 };
 
 /*
- * Focus the editor iframe document or the textarea.
+ * Focus the editor iframe window or the textarea.
  */
-HTMLArea.prototype.focusEditor = function() {
-	switch (this.getMode()) {
-		case "wysiwyg" :
-			try {
-				if (HTMLArea.is_safari) {
-					this._iframe.focus();
-				} else {
-					this._iframe.contentWindow.focus();
-				}
-			} catch(e) { }
-			break;
-		case "textmode":
-			this._textArea.focus();
-			break;
-	}
-	return this._doc;
+HTMLArea.Editor.prototype.focusEditor = function() {
+	this.focus();
+	return this.document;
 };
 
 /*
  * Check if any plugin has an opened window
  */
-HTMLArea.prototype.hasOpenedWindow = function () {
+HTMLArea.Editor.prototype.hasOpenedWindow = function () {
 	for (var plugin in this.plugins) {
 		if (this.plugins.hasOwnProperty(plugin)) {
 			if (HTMLArea.Dialog[plugin.name] && HTMLArea.Dialog[plugin.name].hasOpenedWindow && HTMLArea.Dialog[plugin.name].hasOpenedWindow()) {
@@ -1548,111 +2440,9 @@
 	}
 	return false
 };
-
-/*
- * Update the enabled/disabled/active state of the toolbar elements
- */
-HTMLArea.updateToolbar = function(editorNumber) {
-	var editor = RTEarea[editorNumber]["editor"];
-	editor.updateToolbar();
-	editor._timerToolbar = null;
+HTMLArea.Editor.prototype.updateToolbar = function(noStatus) {
+	this.toolbar.update(noStatus);
 };
-
-HTMLArea.prototype.updateToolbar = function(noStatus) {
-	var doc = this._doc,
-		initialToolbarHeight = this.getDimensions().toolbar.height,
-		text = (this.getMode() == "textmode"),
-		selection = false,
-		ancestors = null,
-		inContext, match, matchAny, k, j, n, commandState;
-	if (!text) {
-		selection = !this._selectionEmpty(this._getSelection());
-		ancestors = this.getAllAncestors();
-	}
-	for (var cmd in this._toolbarObjects) {
-		if (this._toolbarObjects.hasOwnProperty(cmd)) {
-			var btn = this._toolbarObjects[cmd];
-				// Determine if the button should be enabled
-			inContext = true;
-			if (btn.context && !text) {
-				inContext = false;
-				var attrs = [];
-				var contexts = [];
-				if (/(.*)\[(.*?)\]/.test(btn.context)) {
-					contexts = RegExp.$1.split(",");
-					attrs = RegExp.$2.split(",");
-				} else {
-					contexts = btn.context.split(",");
-				}
-				for (j = contexts.length; --j >= 0;) contexts[j] = contexts[j].toLowerCase();
-				matchAny = (contexts[0] == "*");
-				for (k = 0; k < ancestors.length; ++k) {
-					if (!ancestors[k]) continue;
-					match = false;
-					for (j = contexts.length; --j >= 0;) match = match || (ancestors[k].tagName.toLowerCase() == contexts[j]);
-					if (matchAny || match) {
-						inContext = true;
-						for (j = attrs.length; --j >= 0;) {
-							if (!eval("ancestors[k]." + attrs[j])) {
-								inContext = false;
-								break;
-							}
-						}
-						if (inContext) break;
-					}
-				}
-			}
-
-			if (cmd == "CreateLink") {
-				btn.state("enabled", (!text || btn.text) && (inContext || selection));
-			} else {
-				btn.state("enabled", (!text || btn.text) && inContext && (selection || !btn.selection));
-			}
-			if (typeof(cmd) == "function") { continue; };
-				// look-it-up in the custom dropdown boxes
-			var dropdown = this.config.customSelects[cmd];
-			if ((!text || btn.text) && (typeof(dropdown) !== "undefined") && (typeof(dropdown.refresh) === "function")) {
-				dropdown.refresh(this, cmd);
-				continue;
-			}
-			switch (cmd) {
-				case "TextIndicator":
-					if(!text) {
-						try {with (document.getElementById(btn.elementId).style) {
-							backgroundColor = HTMLArea._makeColor(doc.queryCommandValue((HTMLArea.is_ie || HTMLArea.is_safari) ? "BackColor" : "HiliteColor"));
-								// Mozilla
-							if(/transparent/i.test(backgroundColor)) { backgroundColor = HTMLArea._makeColor(doc.queryCommandValue("BackColor")); }
-							color = HTMLArea._makeColor(doc.queryCommandValue("ForeColor"));
-							fontFamily = doc.queryCommandValue("FontName");
-								// Check if queryCommandState is available
-							fontWeight = "normal";
-							fontStyle = "normal";
-							try { fontWeight = doc.queryCommandState("Bold") ? "bold" : "normal"; } catch(ex) { fontWeight = "normal"; };
-							try { fontStyle = doc.queryCommandState("Italic") ? "italic" : "normal"; } catch(ex) { fontStyle = "normal"; };
-						}} catch (e) {
-							// alert(e + "\n\n" + cmd);
-						}
-					}
-					break;
-				default:
-					break;
-			}
-		}
-	}
-	
-	for (var pluginId in this.plugins) {
-		if (this.plugins.hasOwnProperty(pluginId)) {
-			var pluginInstance = this.plugins[pluginId].instance;
-			if (typeof(pluginInstance.onUpdateToolbar) === "function") {
-				pluginInstance.onUpdateToolbar();
-			}
-		}
-	}
-	if (this.getDimensions().toolbar.height != initialToolbarHeight) {
-		this.sizeIframe(2);
-	}
-};
-
 /***************************************************
  *  DOM TREE MANIPULATION
  ***************************************************/
@@ -1661,15 +2451,15 @@
  * Surround the currently selected HTML source code with the given tags.
  * Delete the selection, if any.
  */
-HTMLArea.prototype.surroundHTML = function(startTag,endTag) {
+HTMLArea.Editor.prototype.surroundHTML = function(startTag,endTag) {
 	this.insertHTML(startTag + this.getSelectedHTML().replace(HTMLArea.Reg_body, "") + endTag);
 };
 
 /*
  * Change the tag name of a node.
  */
-HTMLArea.prototype.convertNode = function(el,newTagName) {
-	var newel = this._doc.createElement(newTagName), p = el.parentNode;
+HTMLArea.Editor.prototype.convertNode = function(el,newTagName) {
+	var newel = this.document.createElement(newTagName), p = el.parentNode;
 	while (el.firstChild) newel.appendChild(el.firstChild);
 	p.insertBefore(newel, el);
 	p.removeChild(el);
@@ -1692,7 +2482,7 @@
  *
  * @return	void
  */
-HTMLArea.prototype.removeMarkup = function(element) {
+HTMLArea.Editor.prototype.removeMarkup = function(element) {
 	var bookmark = this.getBookmark(this._createRange(this._getSelection()));
 	var parent = element.parentNode;
 	while (element.firstChild) {
@@ -1732,28 +2522,28 @@
 /*
  * Return true if we have some selected content
  */
-HTMLArea.prototype.hasSelectedText = function() {
+HTMLArea.Editor.prototype.hasSelectedText = function() {
 	return this.getSelectedHTML() != "";
 };
 
 /*
  * Get an array with all the ancestor nodes of the selection.
  */
-HTMLArea.prototype.getAllAncestors = function() {
+HTMLArea.Editor.prototype.getAllAncestors = function() {
 	var p = this.getParentElement();
 	var a = [];
 	while (p && (p.nodeType === 1) && (p.nodeName.toLowerCase() !== "body")) {
 		a.push(p);
 		p = p.parentNode;
 	}
-	a.push(this._doc.body);
+	a.push(this.document.body);
 	return a;
 };
 
 /*
  * Get the block ancestors of an element within a given block
  */
-HTMLArea.prototype.getBlockAncestors = function(element, withinBlock) {
+HTMLArea.Editor.prototype.getBlockAncestors = function(element, withinBlock) {
 	var ancestors = new Array();
 	var ancestor = element;
 	while (ancestor && (ancestor.nodeType === 1) && !/^(body)$/i.test(ancestor.nodeName) && ancestor != withinBlock) {
@@ -1769,9 +2559,9 @@
 /*
  * Get the block elements containing the start and the end points of the selection
  */
-HTMLArea.prototype.getEndBlocks = function(selection) {
+HTMLArea.Editor.prototype.getEndBlocks = function(selection) {
 	var range = this._createRange(selection);
-	if (HTMLArea.is_gecko) {
+	if (!Ext.isIE) {
 		var parentStart = range.startContainer;
 		var parentEnd = range.endContainer;
 	} else {
@@ -1802,7 +2592,7 @@
  *
  * @return	boolean	true if the end points of the current selection are inside the same block element
  */
-HTMLArea.prototype.endPointsInSameBlock = function() {
+HTMLArea.Editor.prototype.endPointsInSameBlock = function() {
 	var selection = this._getSelection();
 	if (this._selectionEmpty(selection)) {
 		return true;
@@ -1817,11 +2607,11 @@
  * Get the deepest ancestor of the selection that is of the specified type
  * Borrowed from Xinha (is not htmlArea) - http://xinha.gogo.co.nz/
  */
-HTMLArea.prototype._getFirstAncestor = function(sel,types) {
+HTMLArea.Editor.prototype._getFirstAncestor = function(sel,types) {
 	var prnt = this._activeElement(sel);
 	if (prnt == null) {
 		try {
-			prnt = (HTMLArea.is_ie ? this._createRange(sel).parentElement() : this._createRange(sel).commonAncestorContainer);
+			prnt = (Ext.isIE ? this._createRange(sel).parentElement() : this._createRange(sel).commonAncestorContainer);
 		} catch(e) {
 			return null;
 		}
@@ -1847,208 +2637,34 @@
  ***************************************************/
 
 /*
- * Intercept some commands and replace them with our own implementation
+ * Intercept some native execCommand commands
  */
-HTMLArea.prototype.execCommand = function(cmdID, UI, param) {
-	this.focusEditor();
+HTMLArea.Editor.prototype.execCommand = function(cmdID, UI, param) {
+	this.focus();
 	switch (cmdID) {
 		default:
 			try {
-				this._doc.execCommand(cmdID, UI, param);
+				this.document.execCommand(cmdID, UI, param);
 			} catch(e) {
 				if (this.config.debug) alert(e + "\n\nby execCommand(" + cmdID + ");");
 			}
 	}
-	this.updateToolbar();
+	this.toolbar.update();
 	return false;
 };
 
-/*
-* A generic event handler for things that happen in the IFRAME's document.
-*/
-HTMLArea._editorEvent = function(ev) {
-	if(!ev) var ev = window.event;
-	var target = (ev.target) ? ev.target : ev.srcElement;
-	var owner = (target.ownerDocument) ? target.ownerDocument : target;
-	if(HTMLArea.is_ie) { // IE5.5 does not report any ownerDocument
-		while (owner.parentElement) { owner = owner.parentElement; }
-	}
-	var editor = RTEarea[owner._editorNo]["editor"];
-	var keyEvent = ((HTMLArea.is_ie || HTMLArea.is_safari) && ev.type == "keydown") || (HTMLArea.is_gecko && ev.type == "keypress");
-	var mouseEvent = (ev.type == "mousedown" || ev.type == "mouseup");
-	editor.focusEditor();
-
-	if(keyEvent) {
-			// In Opera, inhibit key events while synchronous XMLHttpRequest is being processed
-		if (HTMLArea.is_opera && HTMLArea.pendingSynchronousXMLHttpRequest) {
-			HTMLArea._stopEvent(ev);
-			return false;
-		}
-		if (editor._hasPluginWithOnKeyPressHandler) {
-			for (var pluginId in editor.plugins) {
-				if (editor.plugins.hasOwnProperty(pluginId)) {
-					var pluginInstance = editor.plugins[pluginId].instance;
-					if (typeof(pluginInstance.onKeyPress) === "function") {
-						if (!pluginInstance.onKeyPress(ev)) {
-							HTMLArea._stopEvent(ev);
-							return false;
-						}
-					}
-				}
-			}
-		}
-		if (ev.ctrlKey && !ev.shiftKey) {
-			if (!ev.altKey) {
-					// Execute hotkey command
-				var key = String.fromCharCode((HTMLArea.is_ie || HTMLArea.is_safari || HTMLArea.is_opera) ? ev.keyCode : ev.charCode).toLowerCase();
-				if (key == " " || ev.keyCode == 32) {
-					editor.insertHTML("&nbsp;");
-					editor.updateToolbar();
-					HTMLArea._stopEvent(ev);
-					return false;
-				}
-				if (!editor.config.hotKeyList[key]) return true;
-				var cmd = editor.config.hotKeyList[key].cmd;
-				if (!cmd) return true;
-				switch (cmd) {
-					case "SelectAll":
-						cmd = editor.config.hotKeyList[key].cmd;
-						editor.execCommand(cmd, false, null);
-						HTMLArea._stopEvent(ev);
-						return false;
-						break;
-					default:
-						if (editor.config.hotKeyList[key] && editor.config.hotKeyList[key].action) {
-							if (!editor.config.hotKeyList[key].action(editor, key)) {
-								HTMLArea._stopEvent(ev);
-								return false;
-							}
-						}
-				}
-				return true;
-			}
-		} else if (ev.altKey) {
-				// check if context menu is already handling this event
-			if(editor.plugins["ContextMenu"] && editor.plugins["ContextMenu"].instance) {
-				var keys = editor.plugins["ContextMenu"].instance.keys;
-				if (keys.length > 0) {
-					var k;
-					for (var i = keys.length; --i >= 0;) {
-						k = keys[i];
-						if (k[0].toLowerCase() == key) {
-							HTMLArea._stopEvent(ev);
-							return false;
-						}
-					}
-				}
-			}
-			return true;
-		} else if (keyEvent) {
-			if (HTMLArea.is_gecko) editor._detectURL(ev);
-			switch (ev.keyCode) {
-				case 13	: // KEY enter
-					if (HTMLArea.is_gecko) {
-						if (!ev.shiftKey && !editor.config.disableEnterParagraphs) {
-							if (editor._checkInsertP()) {
-								HTMLArea._stopEvent(ev);
-							}
-						} else if (HTMLArea.is_safari) {
-							var brNode = editor._doc.createElement("br");
-							editor.insertNodeAtSelection(brNode);
-							if (!brNode.nextSibling || !HTMLArea.getInnerText(brNode.nextSibling)) {
-								var secondBrNode = editor._doc.createElement("br");
-								secondBrNode = brNode.parentNode.appendChild(secondBrNode);
-								editor.selectNode(secondBrNode, false);
-							}
-							HTMLArea._stopEvent(ev);
-						}
-							// update the toolbar state after some time
-						if (editor._timerToolbar) window.clearTimeout(editor._timerToolbar);
-						editor._timerToolbar = window.setTimeout("HTMLArea.updateToolbar(\'" + editor._editorNumber + "\');", 200);
-						return false;
-					}
-					break;
-				case 8	: // KEY backspace
-				case 46	: // KEY delete
-					if ((HTMLArea.is_gecko && !ev.shiftKey) || HTMLArea.is_ie) {
-						if (editor._checkBackspace()) HTMLArea._stopEvent(ev);
-					}
-						// update the toolbar state after some time
-					if (editor._timerToolbar) window.clearTimeout(editor._timerToolbar);
-					editor._timerToolbar = window.setTimeout("HTMLArea.updateToolbar(\'" + editor._editorNumber + "\');", 200);
-					break;
-				case 9: // KEY horizontal tab
-					var newkey = (ev.shiftKey ? "SHIFT-" : "") + "TAB";
-					if (editor.config.hotKeyList[newkey] && editor.config.hotKeyList[newkey].action) {
-						if (!editor.config.hotKeyList[newkey].action(editor, newkey)) {
-							HTMLArea._stopEvent(ev);
-							return false;
-						}
-					}
-					break;
-				case 37: // LEFT arrow key
-				case 38: // UP arrow key
-				case 39: // RIGHT arrow key
-				case 40: // DOWN arrow key
-					if (HTMLArea.is_ie || HTMLArea.is_safari) {
-						if (editor._timerToolbar) window.clearTimeout(editor._timerToolbar);
-						editor._timerToolbar = window.setTimeout("HTMLArea.updateToolbar(\'" + editor._editorNumber + "\');", 200);
-						return true;
-					}
-					break;
-				default:
-					break;
-			}
-			switch (ev.charCode) {
-				case 160:
-						// Handle option+SPACE for Mac users
-					if (navigator.platform.indexOf("Mac") != -1) {
-						editor.insertHTML("&nbsp;");
-						editor.updateToolbar();
-						HTMLArea._stopEvent(ev);
-						return false;
-					}
-					break;
-				default:
-					break;
-			}
-			return true;
-		}
-	} else if (mouseEvent) {
-			// mouse event
-		if (editor._timerToolbar) window.clearTimeout(editor._timerToolbar);
-		if (ev.type == "mouseup") editor.updateToolbar();
-			else editor._timerToolbar = window.setTimeout("HTMLArea.updateToolbar(\'" + editor._editorNumber + "\');", 50);
-	}
-};
-
-HTMLArea.prototype.scrollToCaret = function() {
-	if (HTMLArea.is_gecko) {
+HTMLArea.Editor.prototype.scrollToCaret = function() {
+	if (!Ext.isIE) {
 		var e = this.getParentElement(),
 			w = this._iframe.contentWindow ? this._iframe.contentWindow : window,
 			h = w.innerHeight || w.height,
-			d = this._doc,
+			d = this.document,
 			t = d.documentElement.scrollTop || d.body.scrollTop;
 		if (e.offsetTop > h+t || e.offsetTop < t) {
 			this.getParentElement().scrollIntoView();
 		}
 	}
 };
-
-/*
- * Get the html content of the current editing mode
- */
-HTMLArea.prototype.getHTML = function() {
-	return this.getPluginInstance("EditorMode").getHTML();
-};
-
-/*
- * Set the given doctype when config.fullPage is true
- */
-HTMLArea.prototype.setDoctype = function(doctype) {
-	this.doctype = doctype;
-};
-
 /***************************************************
  *  UTILITY FUNCTIONS
  ***************************************************/
@@ -2060,118 +2676,10 @@
  * Check if the client agent is supported
  */
 HTMLArea.checkSupportedBrowser = function() {
-	if(HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
-		if(navigator.productSub < 20030210) return false;
-	}
-	return HTMLArea.is_gecko || HTMLArea.is_ie;
+	return Ext.isGecko || Ext.isWebKit || Ext.isOpera || Ext.isIE;
 };
 
-/*	EventCache Version 1.0
- *	Copyright 2005 Mark Wubben
- *	Adaptation by Stanislas Rolland
- *	Provides a way for automatically removing events from nodes and thus preventing memory leakage.
- *	See <http://novemberborn.net/javascript/event-cache> for more information.
- *	This software is licensed under the CC-GNU LGPL <http://creativecommons.org/licenses/LGPL/2.1/>
- *	Event Cache uses an anonymous function to create a hidden scope chain. This is to prevent scoping issues.
- */
-HTMLArea._eventCacheConstructor = function() {
-	var listEvents = [];
-
-	return ({
-		listEvents : listEvents,
-
-		add : function(node, sEventName, fHandler) {
-			listEvents.push(arguments);
-		},
-
-		flush : function() {
-			var item;
-			for (var i = listEvents.length; --i >= 0;) {
-				item = listEvents[i];
-				try {
-					HTMLArea._removeEvent(item[0], item[1], item[2]);
-					item[0][item[1]] = null;
-					item[0] = null;
-					item[2] = null;
-				} catch(e) { }
-			}
-			listEvents.length = 0;
-		}
-	});
-};
-
 /*
- * Register an event
- */
-HTMLArea._addEvent = function(el,evname,func,useCapture) {
-	if (typeof(useCapture) == "undefined") {
-		var useCapture = false;
-	}
-	if (HTMLArea.is_gecko) {
-		el.addEventListener(evname, func, !HTMLArea.is_opera || useCapture);
-	} else {
-		el.attachEvent("on" + evname, func);
-	}
-	HTMLArea._eventCache.add(el, evname, func);
-};
-
-/*
- * Register a list of events
- */
-HTMLArea._addEvents = function(el,evs,func,useCapture) {
-	if (typeof(useCapture) == "undefined") {
-		var useCapture = false;
-	}
-	for (var i = evs.length; --i >= 0;) {
-		HTMLArea._addEvent(el,evs[i], func, useCapture);
-	}
-};
-
-/*
- * Remove an event listener
- */
-HTMLArea._removeEvent = function(el,evname,func) {
-	if (HTMLArea.is_gecko) {
-			// Avoid Safari crash when removing events on some orphan documents
-		if (!HTMLArea.is_safari || HTMLArea.is_chrome) {
-			try {
-				el.removeEventListener(evname, func, true);
-				el.removeEventListener(evname, func, false);
-			} catch(e) { }
-		} else if (el.nodeType != 9 || el.defaultView) {
-			try {
-				el.removeEventListener(evname, func, true);
-				el.removeEventListener(evname, func, false);
-			} catch(e) { }
-		}
-	} else {
-		try {
-			el.detachEvent("on" + evname, func);
-		} catch(e) { }
-	}
-};
-
-/*
- * Remove a list of events
- */
-HTMLArea._removeEvents = function(el,evs,func) {
-	for (var i = evs.length; --i >= 0;) { HTMLArea._removeEvent(el, evs[i], func); }
-};
-
-/*
- * Stop event propagation
- */
-HTMLArea._stopEvent = function(ev) {
-	if(HTMLArea.is_gecko) {
-		ev.stopPropagation();
-		ev.preventDefault();
-	} else {
-		ev.cancelBubble = true;
-		ev.returnValue = false;
-	}
-};
-
-/*
  * Remove a class name from the class attribute of an element
  *
  * @param	object		el: the element
@@ -2193,9 +2701,9 @@
 		}
 	}
 	if (newClasses.length == 0) {
-		if (!HTMLArea.is_opera) {
+		if (!Ext.isOpera) {
 			el.removeAttribute("class");
-			if (HTMLArea.is_ie) {
+			if (Ext.isIE) {
 				el.removeAttribute("className");
 			}
 		} else {
@@ -2240,22 +2748,6 @@
 	return false;
 };
 
-/*
- * Select a value in a select element
- *
- * @param	object		select: the select object
- * @param	string		value: the value
- * @return	void
- */
-HTMLArea.selectValue = function(select, value) {
-	var options = select.getElementsByTagName("option");
-	for (var i = options.length; --i >= 0;) {
-		var option = options[i];
-		option.selected = (option.value == value);
-		select.selectedIndex = i;
-	}
-};
-
 HTMLArea.RE_blockTags = /^(body|p|h1|h2|h3|h4|h5|h6|ul|ol|pre|dl|dt|dd|div|noscript|blockquote|form|hr|table|caption|fieldset|address|td|tr|th|li|tbody|thead|tfoot|iframe)$/;
 HTMLArea.isBlockElement = function(el) { return el && el.nodeType == 1 && HTMLArea.RE_blockTags.test(el.nodeName.toLowerCase()); };
 HTMLArea.RE_closingTags = /^(p|blockquote|a|li|ol|ul|dl|dt|td|th|tr|tbody|thead|tfoot|caption|colgroup|table|div|b|bdo|big|cite|code|del|dfn|em|i|ins|kbd|label|q|samp|small|span|strike|strong|sub|sup|tt|u|var|abbr|acronym|font|center|object|embed|style|script|title|head)$/;
@@ -2295,7 +2787,7 @@
 		HTMLArea._appendToLog("The HTML document is not well-formed.");
 		if(!HTMLArea._debugMode) alert(HTMLArea.I18N.msg["HTML-document-not-well-formed"]);
 			else return HTMLArea.getHTMLWrapper(root,outputRoot,editor);
-		return editor._doc.body.innerHTML;
+		return editor.document.body.innerHTML;
 	}
 };
 
@@ -2315,19 +2807,8 @@
 		if (config.htmlRemoveTagsAndContents && config.htmlRemoveTagsAndContents.test(root_tag)) break;
 		var custom_tag = (config.customTags && config.customTags.test(root_tag));
 		if (outputRoot) outputRoot = !(config.htmlRemoveTags && config.htmlRemoveTags.test(root_tag));
-		if ((HTMLArea.is_ie || HTMLArea.is_safari) && root_tag == "head") {
-			if(outputRoot) html += "<head>";
-			var save_multiline = RegExp.multiline;
-			RegExp.multiline = true;
-			var txt = root.innerHTML.replace(HTMLArea.RE_tagName, function(str, p1, p2) {
-				return p1 + p2.toLowerCase();
-			});
-			RegExp.multiline = save_multiline;
-			html += txt;
-			if(outputRoot) html += "</head>";
-			break;
-		} else if (outputRoot) {
-			if (HTMLArea.is_gecko && root.hasAttribute('_moz_editor_bogus_node')) break;
+		if (outputRoot) {
+			if (Ext.isGecko && root.hasAttribute('_moz_editor_bogus_node')) break;
 			closed = (!(root.hasChildNodes() || HTMLArea.needsClosingTag(root) || custom_tag));
 			html = "<" + root_tag;
 			var a, name, value, attrs = root.attributes;
@@ -2336,14 +2817,14 @@
 				a = attrs.item(i);
 				name = a.nodeName.toLowerCase();
 				if ((!a.specified && name != 'value') || /_moz|contenteditable|_msh|complete/.test(name)) continue;
-				if (!HTMLArea.is_ie || name != "style") {
+				if (!Ext.isIE || name != "style") {
 						// IE5.5 reports wrong values. For this reason we extract the values directly from the root node.
 						// Using Gecko the values of href and src are converted to absolute links unless we get them using nodeValue()
 					if (typeof(root[a.nodeName]) != "undefined" && name != "href" && name != "src" && name != "style" && !/^on/.test(name)) {
 						value = root[a.nodeName];
 					} else {
 						value = a.nodeValue;
-						if (HTMLArea.is_ie && (name == "href" || name == "src") && editor.plugins.link && editor.plugins.link.instance && editor.plugins.link.instance.stripBaseURL) {
+						if (Ext.isIE && (name == "href" || name == "src") && editor.plugins.link && editor.plugins.link.instance && editor.plugins.link.instance.stripBaseURL) {
 							value = editor.plugins.link.instance.stripBaseURL(value);
 						}
 					}
@@ -2353,7 +2834,11 @@
 					// Mozilla reports some special values; we don't need them.
 				if(/(_moz|^$)/.test(value)) continue;
 					// Strip value="0" reported by IE on all li tags
-				if(HTMLArea.is_ie && root_tag == "li" && name == "value" && a.nodeValue == 0) continue;
+				if(Ext.isIE && root_tag == "li" && name == "value" && value == 0) continue;
+					// Strip id generated by ExtJS
+				if (name === 'id' && value.substr(0, 7) === 'ext-gen') {
+					continue;
+				}
 				html += " " + name + '="' + HTMLArea.htmlEncode(value) + '"';
 			}
 			if (html != "") html += closed ? " />" : ">";
